#! /bin/sh

# Expects 2 args:
CXX=$1           # first is name of the compiler
CXXFLAGS=$2      # second contains compilation flags (or empty)

FULLCXX=`which "$CXX" 2>/dev/null`
if [ $? -ne 0 -o \! \( -x "$FULLCXX" -a -r "$FULLCXX" -a -f "$FULLCXX" \) ]
then
  echo "Specified compiler \"$CXX\" is not an executable!"
  exit 1
fi


TMPFILE=/tmp/$HOSTNAME-$UID-$$.C
cat > $TMPFILE <<EOF
#include <iostream>
using namespace std;
int main()
{
#ifdef __GNUC__
  cout << "gnu";
#else
  cout << "not gnu";
#endif
}
EOF
/bin/rm -rf a.out

$CXX $TMPFILE > /dev/null 2>&1
if [ $? -ne 0 -o \! -f a.out -o \! -x a.out ]
then
  /bin/rm -f a.out
  echo "Are you sure \"$CXX\" is a C++ compiler?"
  exit 1
fi
/bin/rm -f a.out

$CXX $CXXFLAGS $TMPFILE > /dev/null 2>&1
if [ $? -ne 0 -o \! -f a.out -o \! -x a.out ]
then
  /bin/rm -f a.out
  echo "Compilation flags \"$CXXFLAGS\" seem to be unsuitable for \"$CXX\""
  exit 1
fi

COMPILER_TYPE=`./a.out`
/bin/rm -f a.out

echo $COMPILER_TYPE
