//   Copyright (c)  1997-2006  John Abbott

//   This file is part of the source of CoCoALib, the CoCoA Library.

//   CoCoALib is free software: you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation, either version 3 of the License, or
//   (at your option) any later version.

//   CoCoALib is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.

//   You should have received a copy of the GNU General Public License
//   along with CoCoALib.  If not, see <http://www.gnu.org/licenses/>.

#include "jtime.h"

#include <stdio.h>
#include <sys/times.h>
#include <limits.h>
#include <unistd.h>

struct tms buffer;

double get_time()
{
  clock_t tmp;
  double hz = (double)(sysconf(_SC_CLK_TCK));

  tmp = times(&buffer);
  return buffer.tms_utime/hz;
}

void print_time()
{
  clock_t tmp;
/*  double hz = (double)(CLK_TCK);*/
  double hz = (double)(sysconf(_SC_CLK_TCK));

  tmp = times(&buffer);
//  if (tmp < 0) { printf("timer error\n"); return; }
  printf("User time = %7.2f, sys time = %7.2f\n", buffer.tms_utime/hz, buffer.tms_stime/hz);
}
